# -*- coding: utf-8 -*-
# AchtDamen.py

### Gute HG+T - Version

# Es wird kein Feld generiert, sondern der Zustand der Belegung wird
# jeweils in einer Liste so gespeichert, dass das Element an erster
# Position den Spaltenidex in der ersten Zeile bezeichnet, das zweite
# den in zweiten Zeile.
    
### ===== diagonalBesetzt =========================================
# Testet die Diagonalen.
def diagonalBesetzt(zustand):
    for i in range(len(zustand)-1):
        # nach rechts unten
        for j in range(i+1,len(zustand)):
            if zustand[j]-zustand[i]==j-i:
                return True
    for i in range(len(zustand)-1):
        # nach links unten
        for j in range(i+1,len(zustand)):
            if zustand[j]+j==zustand[i]+i:
                return True
    return False

### ===== Tiefensuche ================================================
# Die Rekursion verwendet die nachfolgenden Felder.

def tiefensuche(maxZahl=4):
    def intern(zustand, alternativen):
        #print(zustand, alternativen)
        if alternativen==[]: return False
        if diagonalBesetzt(zustand): return False
        if len(zustand)==maxZahl: return zustand
        if alternativen[0] in zustand:
            return intern(zustand, alternativen[1:])
        versuch = intern(zustand+[alternativen[0]], moeglichkeiten)
        if versuch:
            return versuch
        else:
            return intern(zustand, alternativen[1:])
    zustand = []
    moeglichkeiten = []
    for i in range(maxZahl): moeglichkeiten.append(i)
    ergebnis = intern(zustand, moeglichkeiten)
    # 0 basierend in 1 basierend umbauen
    return list(map(lambda x : x+1, ergebnis))

### ===== Darstellung ============================================
def zeigeFeld(zustand):
    print(zustand)
    for i in zustand:
        for j in range(len(zustand)):
            if i-1==j: print('D', end=' ')
            else: print('*', end=' ')
        print()        

### ==============================================================
# Tests:
##print(diagonalBesetzt([1,2]))
##print(diagonalBesetzt([1,3]))
##print(diagonalBesetzt([1,3,5]))
##print(diagonalBesetzt([4,3]))
##print(diagonalBesetzt([4,2]))
tiefensuche(5)
zeigeFeld(tiefensuche(8))
