# -*- coding: utf-8 -*-
# AchtDamen_Zeitmessung.py
###                              Version fuer Python 3.x
### Gute HG+T - Version

# Es wird kein Feld generiert, sondern der Zustand der Belegung wird
# jeweils in einer Liste so gespeichert, dass das Element an erster
# Position den Spaltenidex in der ersten Zeile bezeichnet, das zweite
# den in zweiten Zeile.
    
### ===== diagonalBesetzt =========================================
# Testet die Diagonalen.
def diagonalBesetzt(zustand):
    for i in range(len(zustand)-1):
        # nach rechts unten
        for j in range(i+1,len(zustand)):
            if zustand[j]-zustand[i]==j-i:
                return True
    for i in range(len(zustand)-1):
        # nach links unten
        for j in range(i+1,len(zustand)):
            if zustand[j]+j==zustand[i]+i:
                return True
    return False

### ===== Tiefensuche ================================================
# Die Rekursion verwendet die nachfolgenden Felder.

def tiefensuche(maxZahl=4):
    def intern(zustand, alternativen):
        #print(zustand, alternativen)
        if alternativen==[]: return False
        if diagonalBesetzt(zustand): return False
        if len(zustand)==maxZahl: return zustand
        if alternativen[0] in zustand:
            return intern(zustand, alternativen[1:])
        versuch = intern(zustand+[alternativen[0]], moeglichkeiten)
        if versuch:
            return versuch
        else:
            return intern(zustand, alternativen[1:])
    zustand = []
    moeglichkeiten = []
    for i in range(maxZahl): moeglichkeiten.append(i)
    ergebnis = intern(zustand, moeglichkeiten)
    # 0 basierend in 1 basierend umbauen
    return list(map(lambda x : x+1, ergebnis))

### ===== Darstellung ============================================
def zeigeFeld(zustand):
    print(zustand)
    for i in zustand:
        for j in range(len(zustand)):
            if i-1==j: print('D', end=' ')
            else: print('*', end=' ')
        print()

### ===== suche mit zeitmessung ==================================
import time
def SucheMitZeitmessung(maxZahl=8):
    print(maxZahl, " Damen:")
    start=time.perf_counter()
    f=tiefensuche(maxZahl)
    stopp=time.perf_counter()
    zeigeFeld(f)
    print("Zeit: ", "{:1.3f} Sekunden".format(stopp-start))
    
### ===== Zeitmessung ============================================
### geht, ist aber zu ungenau
##class Zeit():
##    def __init__(self):
##        self.startzeit=None
##        self.stoppzeit=None
##
##    def start(self):
##        self.startzeit=time.gmtime()
##
##    def stopp(self):
##        self.stoppzeit=time.gmtime()
##
##    def dauer(self):
##        werte = [self.stoppzeit.tm_hour-self.startzeit.tm_hour,
##                 self.stoppzeit.tm_min-self.startzeit.tm_min,
##                 self.stoppzeit.tm_sec-self.startzeit.tm_sec]
##        if werte[2]<0:
##            werte[1]-=1
##            werte[2]+=60
##        if werte[1]<0:
##            werte[0]-=1
##            werte[1]+=60
##        return werte
##
##    def zeigeDauer(self):
##        t=self.dauer()
##        print(t[0], " Std ,", t[1], " min ,", t[2], " sec")
##import time
##zeit = Zeit()
##zeit.start()
##zeigeFeld(tiefensuche(16))
##zeit.stopp()
##print(zeit.zeigeDauer())
### ==============================================================
# Tests:
##print(diagonalBesetzt([1,2]))
##print(diagonalBesetzt([1,3]))
##print(diagonalBesetzt([1,3,5]))
##print(diagonalBesetzt([4,3]))
##print(diagonalBesetzt([4,2]))

SucheMitZeitmessung()
##SucheMitZeitmessung(12)
##SucheMitZeitmessung(16)
##SucheMitZeitmessung(18)

